//+------------------------------------------------------------------+
//|                                                CrossedAlerts.mq4 |
//|                                                      Coders Guru |
//|                                         http://www.forex-tsd.com |
//+------------------------------------------------------------------+
#property copyright "Coders Guru"
#property link      "http://www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Blue
#property indicator_color2 Lime
//---- input parameters
extern int       EMA_period=27;

//---- buffers
double TemaBuffer[];
double ExtMapBuffer2[];
double Ema[];
double EmaOfEma[];
double EmaOfEmaOfEma[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
//---- indicators
   IndicatorBuffers(5);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,TemaBuffer);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
 
   SetIndexBuffer(2,Ema);

   SetIndexBuffer(3,EmaOfEma);
 
   SetIndexBuffer(4,EmaOfEmaOfEma);
   SetIndexDrawBegin(0,EMA_period);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);
   
   IndicatorShortName("TEMA("+EMA_period+")");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }

bool Crossed (double line1 , double line2 )
{

static string last_direction = "";
string current_dirction = "";

if(line1>line2)current_dirction = "up";
if(line1<=line2)current_dirction = "down";



if(current_dirction != last_direction) 
{
      Alert("EMA Cross for "+Symbol()+" on the "+Period()+" minute chart.");
      last_direction = current_dirction;
      return (true);
}
else
{
      return (false);

}
 
} 
int start()
  {
   int i,limit,limit2,limit3,counted_bars=IndicatorCounted();
  int pos=Bars-counted_bars;
  
//----
   if (counted_bars==0)
      {
      limit=Bars-1;
      limit2=limit-EMA_period;
      limit3=limit2-EMA_period;
      } 
//---- check for possible errors
   if (counted_bars<0) return(-1);
   
//---- last counted bar will be recounted
   if (counted_bars>0) counted_bars--;
    {
      limit=Bars-counted_bars-1;
      limit2=limit;
      limit3=limit2;
      }
      
   {   
   for (i=limit;i>=0;i--) Ema[i]=iMA(NULL,0,EMA_period,0,MODE_EMA,PRICE_CLOSE,i);
   for (i=limit2;i>=0;i--) EmaOfEma[i]=iMAOnArray(Ema,0,EMA_period,0,MODE_EMA,i);
   for (i=limit3;i>=0;i--) EmaOfEmaOfEma[i]=iMAOnArray(EmaOfEma,0,EMA_period,0,MODE_EMA,i);
   for (i=limit3;i>=0;i--) TemaBuffer[i]=3*Ema[i]-3*EmaOfEma[i]+EmaOfEmaOfEma[i];
  }
 
   
     
 
   while(pos>=0)
     {
         TemaBuffer[pos]= iMA(NULL,0,TemaBuffer[i],0,MODE_EMA,PRICE_CLOSE,pos);

         ExtMapBuffer2[pos]= iMA(NULL,0,21,0,MODE_SMA,PRICE_CLOSE,pos);

         
         pos--;
     }
     
     
     
     Print(Crossed (TemaBuffer[0],ExtMapBuffer2[0]));


//----
   return(0);
  }
//+------------------------------------------------------------------+